#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void local() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
}

void boost() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

ll const MOD = 1e9 + 7;
ll mod(ll a) {
    return a % MOD;
}

bool is_prime(int x) {
    int i = 2;
    while (i * i <= x) {
        if (x % i == 0) return false;
        i++;
    }
    return true;
}

ll min_fac(ll x) {
    ll i = 2;
    while (i * i <= x) {
        if (x % i == 0) return i;
        i++;
    }
    return x;
}

ll bin_pow(ll a, ll n) {
    if (n == 0) return 1;
    else if (n % 2 == 0) return bin_pow(a * a, n / 2);
    else return bin_pow(a, n - 1) * a;
}

ll min(ll a, ll b, ll c) {
    return min(min(a, b), c);
}

struct num {
    ll fac, index, val;
};

bool comp(num n1, num n2) {
    if (n1.fac != n2.fac) return n1.fac < n2.fac;
    return n1.val < n2.val;
}

void solve() {
    ll n;
    cin >> n;
    vector<num> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].val;
        a[i].index = i;
        a[i].fac = min_fac(a[i].val);
    }
    sort(a.begin(), a.end(), comp);
//    for (auto [x, y, z] : a) {
//        cout << x << " " << y << " " << z << endl;
//    }
    vector<ll> ans(n);
    ans[a[0].index] = 1;
    for (int i = 1; i <= n; i++) {
        if ((a[i].val == a[i-1].val) or (a[i].val % a[i-1].val != 0)
        or ((a[i].val % a[i-1].val == 0) and !is_prime(a[i].val / a[i-1].val))) ans[a[i].index] = ans[a[i-1].index];
        else ans[a[i].index] = 3 - ans[a[i-1].index];
    }
    for (auto x : ans) cout << x << " ";

}

int main() {
    boost();
//    local();
    solve();
    return 0;
}