#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void local() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
}

void boost() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

vector<vector<ll>> g;
queue<ll> q;
vector<bool> used;
vector<ll> dist;

void solve() {
    ll n, k, t, a, b;
    cin >> n >> k >> t;
    g.resize(n);
    used.resize(n);
    dist.resize(n);
    for (int i = 0; i < n - 1; i++) {
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    ll c = 1;
    if (t) c = n;
    for (int i = 0; i < c; i++) {
        std::fill(used.begin(), used.end(), false);
        std::fill(dist.begin(), dist.end(), INFINITY);
        used[i] = true;
        q.push(i);
        dist[i] = 0;

        while (!q.empty()) {
            ll v = q.front();
            q.pop();
            for (ll u : g[v]) {
                if (!used[u]) {
                    q.push(u);
                    used[u] = true;
                    dist[u] = dist[v] + 1;
                }
            }
        }
        std::sort(dist.begin(), dist.end(), greater());
        cout << dist[k] << ' ';
//        for (auto i : dist) cout << i << " ";
//        cout << endl;
    }
    cout << '\n';
}

int main() {
    boost();
//    local();
    solve();
    return 0;
}