#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

void local() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
}

void boost() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

vector<vector<int>> g;

void solve() {
    int n, k, t, u, v;
    cin >> n >> k >> t;
    g.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int c = 1;
    if (t) c = n;
    queue<int> q;
    vector<bool> used(n);
    vector<int> dist(n);
    for (int i = 0; i < c; i++) {
        used.assign(n, false);
        dist.assign(n, 0);
        used[i] = true;
        q.push(i);
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for (int u : g[v]) {
                if (!used[u]) {
                    q.push(u);
                    used[u] = true;
                    dist[u] = dist[v] + 1;
                }
            }
        }
        sort(dist.begin(), dist.end(), greater());
        dist[n - 1] = 1;
        if (k > n) cout << "1\n";
        else cout << dist[k] << '\n';
//        for (auto i : dist) cout << i << " ";
//        cout << endl;
    }
}

int main() {
    boost();
//    local();
    int t = 1;
//    cin >> t;
    while (t--) solve();
    return 0;
}