#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

void local() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
}

void boost() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

vector<vector<ll>> g;

void solve() {
    ll n, k, t, a, b;
    cin >> n >> k >> t;
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    ll c = 1;
    if (t) c = n;
    queue<ll> q;
    vector<bool> used(n);
    vector<ll> dist(n);
    for (int i = 0; i < c; i++) {
        used.assign(n, false);
        dist.assign(n, 0);
        used[i] = true;
        q.push(i);

        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for (int u : g[v]) {
                if (!used[u]) {
                    q.push(u);
                    used[u] = true;
                    dist[u] = dist[v] + 1;
                }
            }
        }
        sort(dist.begin(), dist.end(), greater());
        dist[n - 1] = 1;
        if (k > n) cout << "1 ";
        else cout << dist[k] << ' ';
//        for (auto i : dist) cout << i << " ";
//        cout << endl;
    }
    cout << '\n';
}

int main() {
    boost();
//    local();
    solve();
    return 0;
}