#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void local() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
}

void boost() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

bool is_prime(int x) {
    int i = 2;
    while (i * i <= x) {
        if (x % i == 0) return false;
    }
    return true;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first;
        a[i].second = i;
    }
    sort(a.begin(), a.end());
    vector<int> d(n);
    d[a[0].second] = 1;
    for (int i = 1; i < n; i++) {
        if ((a[i].first % a[i - 1].first != 0) or (a[i].first == a[i - 1].first) or !is_prime(a[i].first / a[i - 1].first)) {
            d[i] = d[a[i-1].second];
        }
        else d[i] = 3 - d[a[i-1].second];
    }
    for (auto i : d) cout << i << " ";
}

int main() {
    boost();
//    local();
    solve();
    return 0;
}