#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void local() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
}

void boost() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

ll const MOD = 1e9 + 7;
ll mod(ll a) {
    return a % MOD;
}

bool is_prime(int x) {
    int i = 2;
    while (i * i <= x) {
        if (x % i == 0) return false;
        i++;
    }
    return true;
}

ll min_fac(ll x) {
    ll i = 2;
    while (i * i <= x) {
        if (x % i == 0) return i;
        i++;
    }
    return x;
}

ll bin_pow(ll a, ll n) {
    if (n == 0) return 1;
    else if (n % 2 == 0) return bin_pow(a * a, n / 2);
    else return bin_pow(a, n - 1) * a;
}

ll min(ll a, ll b, ll c) {
    return min(min(a, b), c);
}

void solve() {
    ll n;
    cin >> n;
    vector<pair<ll, ll>> a(n);
    vector<ll> changed(n);
    vector<ll> ans(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first;
        a[i].second = i;
    }
    for (int i = 0; i < n; i++) {
        if (min_fac(a[i].first) != a[i].first) {
            changed[i] = a[i].first;
            a[i].first = min_fac(a[i].first);
        }
    }
    sort(a.begin(), a.end());
    ans[0] = 1;
    for (int i = 1; i < n; i++) {
        cout << a[i].first << " " << a[i].second << " " << changed[a[i].second] << endl;
        if (a[i-1].first == a[i].first and changed[i-1] != changed[i]) ans[i] = 3 - ans[i - 1];
        else ans[i] = ans[i - 1];
    }
    for (auto x : ans) cout << x << " ";

}

int main() {
    boost();
//    local();
    solve();
    return 0;
}