#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void local() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
}

void boost() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

ll const MOD = 1e9 + 7;
ll mod(ll a) {
    return a % MOD;
}

bool is_prime(int x) {
    int i = 2;
    while (i * i <= x) {
        if (x % i == 0) return false;
    }
    return true;
}

ll bin_pow(ll a, ll n) {
    if (n == 0) return 1;
    else if (n % 2 == 0) return bin_pow(a * a, n / 2);
    else return bin_pow(a, n - 1) * a;
}

ll min(ll a, ll b, ll c) {
    return min(min(a, b), c);
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first;
        a[i].second = i;
    }
    sort(a.begin(), a.end());
    vector<int> d(n);
    d[a[0].second] = 1;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if ((a[j].first % a[i].first == 0) and (a[j].first != a[i].first) and is_prime(a[j].first / a[i].first)) {
                d[j] = 3 - d[i];
            }
        }
    }
    for (ll x : d) cout << x << ' ';
}

int main() {
    boost();
//    local();
    solve();
    return 0;
}