#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void local() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
}

void boost() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

ll const MOD = 1e9 + 7;
ll mod(ll a) {
    return a % MOD;
}

bool is_prime(int x) {
    int i = 2;
    while (i * i <= x) {
        if (x % i == 0) return false;
    }
    return true;
}

ll bin_pow(ll a, ll n) {
    if (n == 0) return 1;
    else if (n % 2 == 0) return bin_pow(a * a, n / 2);
    else return bin_pow(a, n - 1) * a;
}

ll min(ll a, ll b, ll c) {
    return min(min(a, b), c);
}

void solve() {
    ll n, x, mx = 0;
    cin >> n;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> x;
        mx = max(mx, x);
        a[i] = x;
    }
    if (mx == 2) {
        for (ll x : a) cout << x << " ";
    }
    else if (mx == 3) {
        for (ll x : a) {
            if (x == 1) cout << 1 << " ";
            else cout << 2 << " ";
        }
    }
    else if (mx == 4) {
        for (ll x : a) {
            if (x == 1 or x == 4) cout << 1 << " ";
            else cout << 2 << " ";
        }
    }
    else {
        for (int i = 0; i < n - 1; i++) {
            cout << 1 << " ";
        } cout << 2 << endl;
    }

}

int main() {
    boost();
//    local();
    solve();
    return 0;
}