#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void local() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
}

void boost() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

bool is_prime(int x) {
    int i = 2;
    while (i * i <= x) {
        if (x % i == 0) return false;
    }
    return true;
}

ll bin_pow(ll a, ll n) {
    if (n == 0) return 1;
    else if (n % 2 == 0) return bin_pow(a * a, n / 2);
    else return bin_pow(a, n - 1) * a;
}

ll count (vector<ll> &a, vector<ll> &t, ll tm, ll n) {
    ll summa = 0;
    for (int i = 0; i < n; i++) {
        if (tm >= a[i] + t[i]) {
            if (tm - a[i] - t[i] + 1 >= 30) return 1e15;
            summa += bin_pow(2, (tm - a[i] - t[i] + 1));
        }
        else if (a[i] <= tm) summa++;
    }
    return summa;
}


void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> a(n), t(n);
    for (ll &x : a) cin >> x;
    for (ll &x : t) cin >> x;

    ll l = 0, r = 1e6;
    while (r - l > 1) {
        ll mid =  (r + l ) / 2;
        if (count(a, t, mid, n) >= m) r = mid;
        else l = mid;
    }
    ll ans = -1;
    if (count(a, t, l, n) == m) ans = l;
    else if (count(a, t, r, n) == m) ans = r;
    cout << ans << endl;
//    cout << count(a, t, 5, n) << endl;
//    cout << count(a, t, 4, n) << endl;
//    cout << count(a, t, 3, n) << endl;
//    cout << bin_pow(2, 9);
}

int main() {
    boost();
//    local();
    solve();
    return 0;
}